searchNodes=[{"doc":"ExStoneOpenbank is a library for calling Stone Open Bank APIs. In order to use this library you need to create an application profile. Please see docs of the service at https://docs.openbank.stone.com.br The steps to use this SDK are: Create a user and open a payment account on Stone Openbank; Create an application profile on Stone Openbank; Add this library to your application; Add configuration for your app(s); Start calling for your bank API. Registration For user registration, just follow the normal flow of signing up for the service. That includes: Register your user; Open a payment account; Wait for approval (you will be notified); Test your account using our web/mobile banking solutions; For application registration, you will need to submit some parameters. Please, refer to our API docs: https://docs.openbank.stone.com.br Library configuration First, add this as a dependency: {:ex_stone_openbank, &quot;~&gt; {{ latest version here }}&quot;} The SDK does not start a supervision tree on its own. So, to configure it you need to add at least two servers to your main application&#39;s supervision tree. This is usually on a file named application.ex. Here is an example: defmodule MyApp.Application do @moduledoc false use Application def start(_type, _args) do children = [ # important JWKS for webhooks! It only uses the :sandbox? key from the config. {ExStoneOpenbank.Webhooks.StoneJWKS, stone_bank()}, # Your application authenticator {ExStoneOpenbank.Authenticator, stone_bank()}, # ... other configurations like Repo, Endpoint and so on ] opts = [strategy: :one_for_one, name: MyApp.Supervisor] Supervisor.start_link(children, opts) end defp stone_bank do [ name: :my_app, private_key: get_private_pem_key(), # fetch the key client_id: get_client_id(), # fetch the client_id sandbox?: true, # tells the environment of the application (see docs) consent_redirect_url: &quot;my url&quot; (only needed if consent is enabled) ] end end The possible configuration parameters are: name (mandatory): will be used on all calls to ExStoneOpenbank private_key (mandatory): must be a PEM encoded string client_id (mandatory): the id of the application registration sandbox? (optional, defaults to false): which environment the app is registered to consent_redirect_url (optional): the URL the service will redirect to once consent is granted by a user Call APIs :) With that you are ready to call any APIs. Those are provided on the namespace ExStoneopenbank.API. For example: ExStoneOpenbank.API.PaymentAccounts: has functions to work with balances, list all accounts and so on ExStoneOpenbank.API.Payments: pays barcode bankslips ExStoneOpenbank.API.Transfers: makes internal (Stone account to Stone account) and external (Stone account to other institution) ... and so on! All APIs expect the config name as the first parameter. This is so to make it possible to have more than one Stone application, each with its own authenticator. Cursor-based pagination endpoints We use cursor-based pagination for list endpoints. Therefore, all endpoints that return a ExStoneOpenbank.Page will have: data: the list of items retrieved cursor: details about the next/before pages and the limit used You can keep paginating with ExStoneOpenbank.Page.next/1 and ExStoneOpenbank.Page.before/1 passing the page result. Here is an example: account_id = # some id {:ok, page} = ExStoneOpenbank.API.PaymentAccounts.list_statements(:my_app, account_id, limit: 50) page.data # =&gt; items # Suppose there are enought items for paginating (if not the response is {:error, :no_more_pages}) {:ok, page2} = ExStoneOpenbank.Page.next(page) {:ok, ^page} = ExStoneOpenbank.Page.before(page2) # You can also query the state before attempting the call ExStoneOpenbank.Page.has_next?(page) # =&gt; true | false","ref":"ExStoneOpenbank.html","title":"ExStoneOpenbank","type":"module"},{"doc":"Configuration options for ExStoneOpenbank","ref":"ExStoneOpenbank.Config.html","title":"ExStoneOpenbank.Config","type":"module"},{"doc":"The Accounts URL for the given configuration name. It&#39;s either: https://sandbox-accounts.openbank.stone.com.br https://accounts.openbank.stone.com.br depending if its a sandbox application or production.","ref":"ExStoneOpenbank.Config.html#accounts_url/1","title":"ExStoneOpenbank.Config.accounts_url/1","type":"function"},{"doc":"The API URL for the given configuration name. It&#39;s either: https://sandbox-api.openbank.stone.com.br https://api.openbank.stone.com.br depending if its a sandbox application or production","ref":"ExStoneOpenbank.Config.html#api_url/1","title":"ExStoneOpenbank.Config.api_url/1","type":"function"},{"doc":"The client_id for the given configuration name.","ref":"ExStoneOpenbank.Config.html#client_id/1","title":"ExStoneOpenbank.Config.client_id/1","type":"function"},{"doc":"The consent_redirect_url for the given configuration name.","ref":"ExStoneOpenbank.Config.html#consent_redirect_url/1","title":"ExStoneOpenbank.Config.consent_redirect_url/1","type":"function"},{"doc":"All options for the given configuration name.","ref":"ExStoneOpenbank.Config.html#options/1","title":"ExStoneOpenbank.Config.options/1","type":"function"},{"doc":"The client_id for the given configuration name.","ref":"ExStoneOpenbank.Config.html#sandbox?/1","title":"ExStoneOpenbank.Config.sandbox?/1","type":"function"},{"doc":"The Joken.Signer.t built from the private key of the given configuration name.","ref":"ExStoneOpenbank.Config.html#signer/1","title":"ExStoneOpenbank.Config.signer/1","type":"function"},{"doc":"Validates given configuration and persists it during boot.","ref":"ExStoneOpenbank.Config.html#validate_and_persist/1","title":"ExStoneOpenbank.Config.validate_and_persist/1","type":"function"},{"doc":"Cursor pagination.","ref":"ExStoneOpenbank.Cursor.html","title":"ExStoneOpenbank.Cursor","type":"module"},{"doc":"","ref":"ExStoneOpenbank.Cursor.html#cast_and_apply/1","title":"ExStoneOpenbank.Cursor.cast_and_apply/1","type":"function"},{"doc":"","ref":"ExStoneOpenbank.Cursor.html#changeset/2","title":"ExStoneOpenbank.Cursor.changeset/2","type":"function"},{"doc":"","ref":"ExStoneOpenbank.Cursor.html#parse_opts/3","title":"ExStoneOpenbank.Cursor.parse_opts/3","type":"function"},{"doc":"","ref":"ExStoneOpenbank.Cursor.html#t:t/0","title":"ExStoneOpenbank.Cursor.t/0","type":"type"},{"doc":"A page on any cursor-based paginated API.","ref":"ExStoneOpenbank.Page.html","title":"ExStoneOpenbank.Page","type":"module"},{"doc":"","ref":"ExStoneOpenbank.Page.html#before/1","title":"ExStoneOpenbank.Page.before/1","type":"function"},{"doc":"","ref":"ExStoneOpenbank.Page.html#cast_and_apply/1","title":"ExStoneOpenbank.Page.cast_and_apply/1","type":"function"},{"doc":"","ref":"ExStoneOpenbank.Page.html#first/1","title":"ExStoneOpenbank.Page.first/1","type":"function"},{"doc":"","ref":"ExStoneOpenbank.Page.html#has_before/1","title":"ExStoneOpenbank.Page.has_before/1","type":"function"},{"doc":"","ref":"ExStoneOpenbank.Page.html#has_next?/1","title":"ExStoneOpenbank.Page.has_next?/1","type":"function"},{"doc":"","ref":"ExStoneOpenbank.Page.html#next/1","title":"ExStoneOpenbank.Page.next/1","type":"function"},{"doc":"","ref":"ExStoneOpenbank.Page.html#t:t/0","title":"ExStoneOpenbank.Page.t/0","type":"type"},{"doc":"An account representation","ref":"ExStoneOpenbank.API.Model.Account.html","title":"ExStoneOpenbank.API.Model.Account","type":"module"},{"doc":"","ref":"ExStoneOpenbank.API.Model.Account.html#cast_and_apply/1","title":"ExStoneOpenbank.API.Model.Account.cast_and_apply/1","type":"function"},{"doc":"","ref":"ExStoneOpenbank.API.Model.Account.html#t:t/0","title":"ExStoneOpenbank.API.Model.Account.t/0","type":"type"},{"doc":"Details about the barcode payment","ref":"ExStoneOpenbank.API.Model.BarcodePaymentDetails.html","title":"ExStoneOpenbank.API.Model.BarcodePaymentDetails","type":"module"},{"doc":"","ref":"ExStoneOpenbank.API.Model.BarcodePaymentDetails.html#cast_and_apply/1","title":"ExStoneOpenbank.API.Model.BarcodePaymentDetails.cast_and_apply/1","type":"function"},{"doc":"","ref":"ExStoneOpenbank.API.Model.BarcodePaymentDetails.html#t:t/0","title":"ExStoneOpenbank.API.Model.BarcodePaymentDetails.t/0","type":"type"},{"doc":"Input for a barcode payment.","ref":"ExStoneOpenbank.API.Model.BarcodePaymentInput.html","title":"ExStoneOpenbank.API.Model.BarcodePaymentInput","type":"module"},{"doc":"","ref":"ExStoneOpenbank.API.Model.BarcodePaymentInput.html#cast_and_apply/1","title":"ExStoneOpenbank.API.Model.BarcodePaymentInput.cast_and_apply/1","type":"function"},{"doc":"","ref":"ExStoneOpenbank.API.Model.BarcodePaymentInput.html#t:t/0","title":"ExStoneOpenbank.API.Model.BarcodePaymentInput.t/0","type":"type"},{"doc":"Response of a successful barcode payment (or a barcode payment dry run)","ref":"ExStoneOpenbank.API.Model.BarcodePaymentResponse.html","title":"ExStoneOpenbank.API.Model.BarcodePaymentResponse","type":"module"},{"doc":"","ref":"ExStoneOpenbank.API.Model.BarcodePaymentResponse.html#cast_and_apply/1","title":"ExStoneOpenbank.API.Model.BarcodePaymentResponse.cast_and_apply/1","type":"function"},{"doc":"","ref":"ExStoneOpenbank.API.Model.BarcodePaymentResponse.html#t:t/0","title":"ExStoneOpenbank.API.Model.BarcodePaymentResponse.t/0","type":"type"},{"doc":"Counter party model","ref":"ExStoneOpenbank.API.Model.CounterParty.html","title":"ExStoneOpenbank.API.Model.CounterParty","type":"module"},{"doc":"","ref":"ExStoneOpenbank.API.Model.CounterParty.html#cast_and_apply/1","title":"ExStoneOpenbank.API.Model.CounterParty.cast_and_apply/1","type":"function"},{"doc":"","ref":"ExStoneOpenbank.API.Model.CounterParty.html#t:t/0","title":"ExStoneOpenbank.API.Model.CounterParty.t/0","type":"type"},{"doc":"Input for a barcode payment dry run.","ref":"ExStoneOpenbank.API.Model.DryRunBarcodePaymentInput.html","title":"ExStoneOpenbank.API.Model.DryRunBarcodePaymentInput","type":"module"},{"doc":"","ref":"ExStoneOpenbank.API.Model.DryRunBarcodePaymentInput.html#cast_and_apply/1","title":"ExStoneOpenbank.API.Model.DryRunBarcodePaymentInput.cast_and_apply/1","type":"function"},{"doc":"","ref":"ExStoneOpenbank.API.Model.DryRunBarcodePaymentInput.html#t:t/0","title":"ExStoneOpenbank.API.Model.DryRunBarcodePaymentInput.t/0","type":"type"},{"doc":"A legal entity that can be either a user or an organization.","ref":"ExStoneOpenbank.API.Model.Entity.html","title":"ExStoneOpenbank.API.Model.Entity","type":"module"},{"doc":"","ref":"ExStoneOpenbank.API.Model.Entity.html#cast_and_apply/1","title":"ExStoneOpenbank.API.Model.Entity.cast_and_apply/1","type":"function"},{"doc":"","ref":"ExStoneOpenbank.API.Model.Entity.html#t:t/0","title":"ExStoneOpenbank.API.Model.Entity.t/0","type":"type"},{"doc":"PaymentAccount model","ref":"ExStoneOpenbank.API.Model.PaymentAccount.html","title":"ExStoneOpenbank.API.Model.PaymentAccount","type":"module"},{"doc":"","ref":"ExStoneOpenbank.API.Model.PaymentAccount.html#cast_and_apply/1","title":"ExStoneOpenbank.API.Model.PaymentAccount.cast_and_apply/1","type":"function"},{"doc":"","ref":"ExStoneOpenbank.API.Model.PaymentAccount.html#t:t/0","title":"ExStoneOpenbank.API.Model.PaymentAccount.t/0","type":"type"},{"doc":"Permission model","ref":"ExStoneOpenbank.API.Model.Permission.html","title":"ExStoneOpenbank.API.Model.Permission","type":"module"},{"doc":"","ref":"ExStoneOpenbank.API.Model.Permission.html#cast_and_apply/1","title":"ExStoneOpenbank.API.Model.Permission.cast_and_apply/1","type":"function"},{"doc":"","ref":"ExStoneOpenbank.API.Model.Permission.html#changeset/2","title":"ExStoneOpenbank.API.Model.Permission.changeset/2","type":"function"},{"doc":"","ref":"ExStoneOpenbank.API.Model.Permission.html#t:t/0","title":"ExStoneOpenbank.API.Model.Permission.t/0","type":"type"},{"doc":"StatementEntry model","ref":"ExStoneOpenbank.API.Model.StatementEntry.html","title":"ExStoneOpenbank.API.Model.StatementEntry","type":"module"},{"doc":"","ref":"ExStoneOpenbank.API.Model.StatementEntry.html#cast_and_apply/1","title":"ExStoneOpenbank.API.Model.StatementEntry.cast_and_apply/1","type":"function"},{"doc":"","ref":"ExStoneOpenbank.API.Model.StatementEntry.html#t:t/0","title":"ExStoneOpenbank.API.Model.StatementEntry.t/0","type":"type"},{"doc":"Account model","ref":"ExStoneOpenbank.API.Model.TransferAccount.html","title":"ExStoneOpenbank.API.Model.TransferAccount","type":"module"},{"doc":"","ref":"ExStoneOpenbank.API.Model.TransferAccount.html#cast_and_apply/1","title":"ExStoneOpenbank.API.Model.TransferAccount.cast_and_apply/1","type":"function"},{"doc":"","ref":"ExStoneOpenbank.API.Model.TransferAccount.html#t:t/0","title":"ExStoneOpenbank.API.Model.TransferAccount.t/0","type":"type"},{"doc":"Account model","ref":"ExStoneOpenbank.API.Model.TransferEntity.html","title":"ExStoneOpenbank.API.Model.TransferEntity","type":"module"},{"doc":"","ref":"ExStoneOpenbank.API.Model.TransferEntity.html#cast_and_apply/1","title":"ExStoneOpenbank.API.Model.TransferEntity.cast_and_apply/1","type":"function"},{"doc":"","ref":"ExStoneOpenbank.API.Model.TransferEntity.html#t:t/0","title":"ExStoneOpenbank.API.Model.TransferEntity.t/0","type":"type"},{"doc":"Internal transfer input model.","ref":"ExStoneOpenbank.API.Model.TransferInput.html","title":"ExStoneOpenbank.API.Model.TransferInput","type":"module"},{"doc":"","ref":"ExStoneOpenbank.API.Model.TransferInput.html#cast_and_apply/1","title":"ExStoneOpenbank.API.Model.TransferInput.cast_and_apply/1","type":"function"},{"doc":"","ref":"ExStoneOpenbank.API.Model.TransferInput.html#t:t/0","title":"ExStoneOpenbank.API.Model.TransferInput.t/0","type":"type"},{"doc":"A transfer representation","ref":"ExStoneOpenbank.API.Model.TransferResponse.html","title":"ExStoneOpenbank.API.Model.TransferResponse","type":"module"},{"doc":"","ref":"ExStoneOpenbank.API.Model.TransferResponse.html#cast_and_apply/1","title":"ExStoneOpenbank.API.Model.TransferResponse.cast_and_apply/1","type":"function"},{"doc":"","ref":"ExStoneOpenbank.API.Model.TransferResponse.html#t:t/0","title":"ExStoneOpenbank.API.Model.TransferResponse.t/0","type":"type"},{"doc":"Target of a transfer.","ref":"ExStoneOpenbank.API.Model.TransferTarget.html","title":"ExStoneOpenbank.API.Model.TransferTarget","type":"module"},{"doc":"","ref":"ExStoneOpenbank.API.Model.TransferTarget.html#cast_and_apply/1","title":"ExStoneOpenbank.API.Model.TransferTarget.cast_and_apply/1","type":"function"},{"doc":"","ref":"ExStoneOpenbank.API.Model.TransferTarget.html#t:t/0","title":"ExStoneOpenbank.API.Model.TransferTarget.t/0","type":"type"},{"doc":"Retrieves all resources the application has access to.","ref":"ExStoneOpenbank.API.PaymentAccounts.html","title":"ExStoneOpenbank.API.PaymentAccounts","type":"module"},{"doc":"Get the given account&#39;s statement as a paginated list.","ref":"ExStoneOpenbank.API.PaymentAccounts.html#get_statement/3","title":"ExStoneOpenbank.API.PaymentAccounts.get_statement/3","type":"function"},{"doc":"List all accounts which the current token can access.","ref":"ExStoneOpenbank.API.PaymentAccounts.html#list/2","title":"ExStoneOpenbank.API.PaymentAccounts.list/2","type":"function"},{"doc":"Payments calls","ref":"ExStoneOpenbank.API.Payments.html","title":"ExStoneOpenbank.API.Payments","type":"module"},{"doc":"Dry run the payment of a barcode. This is needed in order to understand the details of the payment and show it up front to users.","ref":"ExStoneOpenbank.API.Payments.html#dry_run_pay_barcode/2","title":"ExStoneOpenbank.API.Payments.dry_run_pay_barcode/2","type":"function"},{"doc":"Pay a barcode.","ref":"ExStoneOpenbank.API.Payments.html#pay_barcode/2","title":"ExStoneOpenbank.API.Payments.pay_barcode/2","type":"function"},{"doc":"Retrieves all resources the application has access to.","ref":"ExStoneOpenbank.API.Resources.html","title":"ExStoneOpenbank.API.Resources","type":"module"},{"doc":"","ref":"ExStoneOpenbank.API.Resources.html#list/2","title":"ExStoneOpenbank.API.Resources.list/2","type":"function"},{"doc":"Transfers operations.","ref":"ExStoneOpenbank.API.Transfers.html","title":"ExStoneOpenbank.API.Transfers","type":"module"},{"doc":"Dry run a transfer. This is needed in order to understand the details of the payment and show it up front to users.","ref":"ExStoneOpenbank.API.Transfers.html#dry_run_transfer/2","title":"ExStoneOpenbank.API.Transfers.dry_run_transfer/2","type":"function"},{"doc":"Make transfer","ref":"ExStoneOpenbank.API.Transfers.html#transfer/2","title":"ExStoneOpenbank.API.Transfers.transfer/2","type":"function"},{"doc":"Handles incoming webhooks. A webhook is a JSON object with only the key encrypted_body and a JWE as its value. The algorithm used is RSA-OAEP-256 of the JWA specification.","ref":"ExStoneOpenbank.Webhooks.html","title":"ExStoneOpenbank.Webhooks","type":"module"},{"doc":"Validate and open the webhook payload. First, it decrypts using our private key. Then, we validate the contents with a known public key (see ExStoneOpenbank.Webhooks.StoneJWKS). If all is valid, we return the contents. This function needs a recent OTP version compiled with a recent OpenSSL library version.","ref":"ExStoneOpenbank.Webhooks.html#incoming/2","title":"ExStoneOpenbank.Webhooks.incoming/2","type":"function"},{"doc":"A token configuration used to verify the JWT token signed by Stone.","ref":"ExStoneOpenbank.Webhooks.StoneJWKS.html","title":"ExStoneOpenbank.Webhooks.StoneJWKS","type":"module"},{"doc":"Returns a specification to start this module under a supervisor. arg is passed as the argument to Task.start_link/1 in the :start field of the spec. For more information, see the Supervisor module, the Supervisor.child_spec/2 function and the Supervisor.child_spec/0 type.","ref":"ExStoneOpenbank.Webhooks.StoneJWKS.html#child_spec/1","title":"ExStoneOpenbank.Webhooks.StoneJWKS.child_spec/1","type":"function"},{"doc":"Fetch signers with JokenJwks.HttpFetcher","ref":"ExStoneOpenbank.Webhooks.StoneJWKS.html#fetch_signers/2","title":"ExStoneOpenbank.Webhooks.StoneJWKS.fetch_signers/2","type":"function"},{"doc":"Simple ETS counter based state machine","ref":"ExStoneOpenbank.Webhooks.StoneJWKS.EtsCache.html","title":"ExStoneOpenbank.Webhooks.StoneJWKS.EtsCache","type":"module"},{"doc":"Returns 0 - no need to fetch signers or 1 - need to fetch","ref":"ExStoneOpenbank.Webhooks.StoneJWKS.EtsCache.html#check_state/0","title":"ExStoneOpenbank.Webhooks.StoneJWKS.EtsCache.check_state/0","type":"function"},{"doc":"Loads fetched signers","ref":"ExStoneOpenbank.Webhooks.StoneJWKS.EtsCache.html#get_signers/0","title":"ExStoneOpenbank.Webhooks.StoneJWKS.EtsCache.get_signers/0","type":"function"},{"doc":"Starts ETS cache","ref":"ExStoneOpenbank.Webhooks.StoneJWKS.EtsCache.html#new/0","title":"ExStoneOpenbank.Webhooks.StoneJWKS.EtsCache.new/0","type":"function"},{"doc":"Puts fetched signers","ref":"ExStoneOpenbank.Webhooks.StoneJWKS.EtsCache.html#put_signers/1","title":"ExStoneOpenbank.Webhooks.StoneJWKS.EtsCache.put_signers/1","type":"function"},{"doc":"Sets the cache status","ref":"ExStoneOpenbank.Webhooks.StoneJWKS.EtsCache.html#set_status/1","title":"ExStoneOpenbank.Webhooks.StoneJWKS.EtsCache.set_status/1","type":"function"},{"doc":"A webhook arrives as an encrypted token (JWE). After decrypting it we get a JWT signed by Stone&#39;s public keys. We must validate its signature so that we can use the payload.","ref":"ExStoneOpenbank.Webhooks.StoneJWTConfig.html","title":"ExStoneOpenbank.Webhooks.StoneJWTConfig","type":"module"},{"doc":"Combines generate_claims/1 and encode_and_sign/2","ref":"ExStoneOpenbank.Webhooks.StoneJWTConfig.html#generate_and_sign/2","title":"ExStoneOpenbank.Webhooks.StoneJWTConfig.generate_and_sign/2","type":"function"},{"doc":"Same as generate_and_sign/2 but raises if error","ref":"ExStoneOpenbank.Webhooks.StoneJWTConfig.html#generate_and_sign!/2","title":"ExStoneOpenbank.Webhooks.StoneJWTConfig.generate_and_sign!/2","type":"function"},{"doc":"Combines verify/2 and validate/1","ref":"ExStoneOpenbank.Webhooks.StoneJWTConfig.html#verify_and_validate/3","title":"ExStoneOpenbank.Webhooks.StoneJWTConfig.verify_and_validate/3","type":"function"},{"doc":"Same as verify_and_validate/2 but raises if error","ref":"ExStoneOpenbank.Webhooks.StoneJWTConfig.html#verify_and_validate!/3","title":"ExStoneOpenbank.Webhooks.StoneJWTConfig.verify_and_validate!/3","type":"function"},{"doc":"Consent is the way to request access to a resource in Stone Open Bank API.","ref":"ExStoneOpenbank.Consents.html","title":"ExStoneOpenbank.Consents","type":"module"},{"doc":"Generates a consent link using Stone Open Bank specification.","ref":"ExStoneOpenbank.Consents.html#generate_link/2","title":"ExStoneOpenbank.Consents.generate_link/2","type":"function"},{"doc":"Token configuration for the consent link.","ref":"ExStoneOpenbank.Consents.Token.html","title":"ExStoneOpenbank.Consents.Token","type":"module"},{"doc":"Convenience function for generating a token for a config name","ref":"ExStoneOpenbank.Consents.Token.html#generate/2","title":"ExStoneOpenbank.Consents.Token.generate/2","type":"function"},{"doc":"Combines generate_claims/1 and encode_and_sign/2","ref":"ExStoneOpenbank.Consents.Token.html#generate_and_sign/2","title":"ExStoneOpenbank.Consents.Token.generate_and_sign/2","type":"function"},{"doc":"Same as generate_and_sign/2 but raises if error","ref":"ExStoneOpenbank.Consents.Token.html#generate_and_sign!/2","title":"ExStoneOpenbank.Consents.Token.generate_and_sign!/2","type":"function"},{"doc":"Combines verify/2 and validate/1","ref":"ExStoneOpenbank.Consents.Token.html#verify_and_validate/3","title":"ExStoneOpenbank.Consents.Token.verify_and_validate/3","type":"function"},{"doc":"Same as verify_and_validate/2 but raises if error","ref":"ExStoneOpenbank.Consents.Token.html#verify_and_validate!/3","title":"ExStoneOpenbank.Consents.Token.verify_and_validate!/3","type":"function"},{"doc":"Responsible for authentication of the service application. Authentication is done through issuing a JWT to the token endpoint according to client_credentials flow. The JWT is signed using the private key in the given configuration. The result is an access_token and a refresh_token. The access_token is used in all authenticated calls. The refresh token is used to get a new access_token without issuing a new token.","ref":"ExStoneOpenbank.Authenticator.html","title":"ExStoneOpenbank.Authenticator","type":"module"},{"doc":"Gets the access_token for the given configuration.","ref":"ExStoneOpenbank.Authenticator.html#access_token/1","title":"ExStoneOpenbank.Authenticator.access_token/1","type":"function"},{"doc":"Authenticates with Stone Openbank API using the given signer and client_id","ref":"ExStoneOpenbank.Authenticator.html#authenticate/1","title":"ExStoneOpenbank.Authenticator.authenticate/1","type":"function"},{"doc":"Returns a specification to start this module under a supervisor. See Supervisor.","ref":"ExStoneOpenbank.Authenticator.html#child_spec/1","title":"ExStoneOpenbank.Authenticator.child_spec/1","type":"function"},{"doc":"Refreshes the token synchronously","ref":"ExStoneOpenbank.Authenticator.html#refresh_token/1","title":"ExStoneOpenbank.Authenticator.refresh_token/1","type":"function"},{"doc":"","ref":"ExStoneOpenbank.Authenticator.html#start_link/1","title":"ExStoneOpenbank.Authenticator.start_link/1","type":"function"},{"doc":"A Tesla Middleware that ensures we always have a valid access_token. This middleware implementation has a retryable approach. It tries the call with the current token available. It might get a 401 at first and so, it calls for a refresh on the authenticator. This may block if the authenticator is trying to renew the token. When it gets a possibly new token it will retry the same call with the new token. In the case that it fails again, it will repeat this flow for 5 times (configured default limit of retries). If it fails after that, it will return the error. This authentication flow is necessary to ensure we use the token the best way we can and avoid authenticating on every call.","ref":"ExStoneOpenbank.Authenticator.AuthHTTPMiddleware.html","title":"ExStoneOpenbank.Authenticator.AuthHTTPMiddleware","type":"module"},{"doc":"Responsible for the JWT generation used in the client_credentials authentication flow.","ref":"ExStoneOpenbank.Authenticator.AuthenticationJWT.html","title":"ExStoneOpenbank.Authenticator.AuthenticationJWT","type":"module"},{"doc":"Combines generate_claims/1 and encode_and_sign/2","ref":"ExStoneOpenbank.Authenticator.AuthenticationJWT.html#generate_and_sign/2","title":"ExStoneOpenbank.Authenticator.AuthenticationJWT.generate_and_sign/2","type":"function"},{"doc":"Same as generate_and_sign/2 but raises if error","ref":"ExStoneOpenbank.Authenticator.AuthenticationJWT.html#generate_and_sign!/2","title":"ExStoneOpenbank.Authenticator.AuthenticationJWT.generate_and_sign!/2","type":"function"},{"doc":"Combines verify/2 and validate/1","ref":"ExStoneOpenbank.Authenticator.AuthenticationJWT.html#verify_and_validate/3","title":"ExStoneOpenbank.Authenticator.AuthenticationJWT.verify_and_validate/3","type":"function"},{"doc":"Same as verify_and_validate/2 but raises if error","ref":"ExStoneOpenbank.Authenticator.AuthenticationJWT.html#verify_and_validate!/3","title":"ExStoneOpenbank.Authenticator.AuthenticationJWT.verify_and_validate!/3","type":"function"},{"doc":"ExStoneOpenbank A library that connects with Stone Open Banking API.","ref":"readme.html","title":"ExStoneOpenbank","type":"extras"},{"doc":"If available in Hex, the package can be installed by adding ex_stone_openbank to your list of dependencies in mix.exs: def deps do [ {:ex_stone_openbank, &quot;~&gt; 0.1.0&quot;} ] end Documentation can be generated with ExDoc and published on HexDocs. Once published, the docs can be found at https://hexdocs.pm/ex_stone_openbank.","ref":"readme.html#installation","title":"ExStoneOpenbank - Installation","type":"extras"},{"doc":"Changelog All notable changes to this project will be documented in this file. The format is based on Keep a Changelog, and this project adheres to Semantic Versioning.","ref":"changelog.html","title":"Changelog","type":"extras"},{"doc":"","ref":"changelog.html#unreleased","title":"Changelog - [Unreleased]","type":"extras"},{"doc":"Fixed Fixed payments scheduled_to","ref":"changelog.html#0-1-1-2020-02-24","title":"Changelog - [0.1.1] - 2020-02-24","type":"extras"},{"doc":"Initial release","ref":"changelog.html#0-1-0-2020-01-21","title":"Changelog - [0.1.0] - 2020-01-21","type":"extras"}]